unit ZipMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm5 = class(TForm)
    BtnSelect: TButton;
    BtnUnzipSelected: TButton;
    lbxFileNames: TListBox;
    BtnUnzipAll: TButton;
    Label1: TLabel;
    eUnzipFolder: TEdit;
    eZipFolder: TEdit;
    Label2: TLabel;
    BtnListFiles: TButton;
    lbxDestFiles: TListBox;
    BtnZip: TButton;
    BtnZipAll: TButton;
    LblZipContents: TLabel;
    procedure BtnSelectClick(Sender: TObject);
    procedure BtnUnzipAllClick(Sender: TObject);
    procedure BtnUnzipSelectedClick(Sender: TObject);
    procedure BtnListFilesClick(Sender: TObject);
    procedure BtnZipClick(Sender: TObject);
    procedure BtnZipAllClick(Sender: TObject);
  private
    FZipFileName: TFileName;
  public
  end;

var
  Form5: TForm5;

implementation

{$R *.dfm}

uses
  ZipUtils, IOUtils;

procedure TForm5.BtnListFilesClick(Sender: TObject);
var
  fileName: string;
begin
  lbxDestFiles.Clear;
  for fileName in TDirectory.GetFiles(eUnzipFolder.Text) do begin
    lbxDestFiles.Items.Add(ExtractFileName(fileName));
  end;
end;

procedure TForm5.BtnSelectClick(Sender: TObject);
var
  od: TOpenDialog;
  fileName: string;
begin
  od := TOpenDialog.Create(self);
  od.InitialDir := eZipFolder.Text;
  od.Filter := 'Zip files|*.zip';
  od.FilterIndex := 0;
  if od.Execute then begin
    FZipFileName := od.FileName;
    LblZipContents.Caption := 'Contents of ' + FZipFileName;
    // fill list box with filenames in selected zip file
    lbxFileNames.Clear;
    for fileName in ZipUtils.ListArchive(FZipFileName) do
      lbxFileNames.Items.Add(fileName);
  end;
end;

procedure TForm5.BtnUnzipAllClick(Sender: TObject);
begin
  if lbxFileNames.Count > 0 then begin
    if ZipUtils.DecompressArchive(FZipFileName, eUnzipFolder.Text) then
      ShowMessage('Unzipped ' + FZipFileName)
    else
      ShowMessage('Failed to unzip ' + FZipFileName);
  end;
end;

procedure TForm5.BtnUnzipSelectedClick(Sender: TObject);
var
  fileName: string;
begin
  if lbxFileNames.ItemIndex >= 0 then begin
    fileName := lbxFileNames.Items[lbxFileNames.ItemIndex];
    if ZipUtils.DecompressFile(FZipFileName, fileName, eUnzipFolder.Text) then
      ShowMessage('Unzipped ' + fileName)
    else
      ShowMessage('Failed to unzip ' + fileName);
  end;end;

procedure TForm5.BtnZipAllClick(Sender: TObject);
var
  sd: TSaveDialog;
begin
  sd := TSaveDialog.Create(self);
  if sd.Execute then begin
    ZipUtils.CompressArchive(eUnzipFolder.Text, sd.FileName);
  end;
end;

procedure TForm5.BtnZipClick(Sender: TObject);
var
  sd: TSaveDialog;
  fileName: string;
begin
  if lbxDestFiles.ItemIndex >= 0 then begin
    fileName := lbxDestFiles.Items[lbxDestFiles.ItemIndex];
    sd := TSaveDialog.Create(self);
    sd.InitialDir := eZipFolder.Text;
    sd.Filter := 'Zip files|*.zip';
    sd.FilterIndex := 0;
    sd.DefaultExt := '.zip';
    if sd.Execute then begin
      ZipUtils.CompressFile(eUnzipFolder.Text + '\' + fileName, sd.FileName);
    end;
  end;
end;

end.
