unit ZipUtils;

// http://qc.embarcadero.com/wc/qcmain.aspx?d=99443

// version 16 = XE2, 17 = XE3


interface

type
  StringArray = TArray<string>;

function ListArchive(const ZipFileName: string): StringArray;
function DecompressFile(const ZipFileName, FileName, DestinationFolder: string): boolean;
function DecompressArchive(const ZipFileName, DestinationFolder: string): boolean;
function CompressArchive(const SourceFolder, ZipFileName: string): boolean;
function CompressFile(const FileName, ZipFileName: string): Boolean;

implementation

uses SysUtils, System.Zip;

function ListArchive(const ZipFileName: string): StringArray;
var
  zipFile: TZipFile;
begin
  zipFile := TZipFile.Create;
  try
    zipFile.Open(ZipFileName, zmRead);
    Result := zipFile.Filenames;
    zipFile.Close;
  finally
    zipFile.Free;
  end;
end;

function DecompressFile(const ZipFileName, FileName, DestinationFolder: string): boolean;
var
  zf: TZipFile;
begin
  Result := TZipFile.IsValid(ZipFileName);
  if Result then begin
    zf := TZipFile.Create;
    try
      zf.Open(ZipFileName, TZipMode.zmRead);
      zf.Extract(FileName, DestinationFolder);
    finally
      zf.Free;
    end;
  end;
end;

function DecompressArchive(const ZipFileName, DestinationFolder: string): boolean;
begin
  Result := TZipFile.IsValid(ZipFileName);
  if result then
    TZipFile.ExtractZipFile(ZipFileName, DestinationFolder);
end;

function CompressArchive(const SourceFolder, ZipFileName: string): boolean;
begin
  TZipFile.ZipDirectoryContents(ZipFileName, SourceFolder);
  Result := TZipFile.IsValid(ZipFileName);
end;

function CompressFile(const FileName, ZipFileName: string): Boolean;
var
  zipFile : TZipFile;
begin
  zipFile := TZipFile.Create;
  try
    zipFile.Open(ZipFileName, zmWrite);
    zipFile.Add(FileName);
    zipFile.Close;
    Result := True;
  finally
    zipFile.Free;
  end;
end;

end.
